function img_maze = Plot_maze( elements,t_set,tile_sz )

% % Plot_maze
% This function plots a maze generated by the Maze_gen
% function
% 
% USAGE:
% img_maze = Plot_maze( elements,t_set,tile_sz )
% elements - matrix representing the array generated by the Maze_gen
% function
% t_set - an array describing the meaning of each possible value in the 
% elements array
% tile_sz - the size of individual images that the maze is composed of 
% (USA 100 if you use the images supplied in this example)

img_maze=zeros(size(elements,1),size(elements,2),3);

for i=1:1:numel(t_set)
    x_arr=[];
    y_arr=[];
    [x_arr,y_arr]=find(elements==i);
    tile_img=[];
    tile_img=imread(strcat('pics/',t_set{i},'.bmp'));
    tile_img=double(tile_img)/256;
    for j=1:1:numel(x_arr)
        
        img_maze(((x_arr(j)-1)*tile_sz+1):1:((x_arr(j))*tile_sz),((y_arr(j)-1)*tile_sz+1):1:((y_arr(j))*tile_sz),1:1:3)=...
            tile_img(1:1:size(tile_img,1),1:1:size(tile_img,2),1:1:3);
    end
end



end

