close all; clc;

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                                                           %%
%%                              Jeu Labyrinthe avec Arduino et Matlab #2/2                                  %%
%%                  Lien: https://www.electronique-mixte.fr/manette-de-jeu-infrarouge-avec-arduino/         %%
%                                                                                                           %%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% Open Serial Port

SerialCOM = Open(); % Open new port

%% Programme principal

% Params Labyrinthe
sz=10;
tile_sz=100;
tangling_steps=300;
growing_steps=900;

% Gnration LABY
[elements,t_set] = Maze_gen( sz,tangling_steps,growing_steps);
img_maze = Plot_maze( elements,t_set,tile_sz);

% Taille du joueur  NxN
N=20;

% Dplacement en pixel
Pas=round(N/2);

% Coordonnes de la position initiale du joueur (x0, y0)
img_maze0=img_maze; im_rgb=((im2uint8(img_maze0)));
pix =[236 28 36];
x_y=GetPixel(im_rgb, pix);
Start_y_0=x_y(1);Start_y=Start_y_0;
Start_x_0=x_y(2); Start_x=Start_x_0;

% Manette
Manette=ones(1,4);
Seuil_outZone=0.3;

% Positionner le joueur sur (x0, y0)
img_maze0(Start_y_0:Start_y_0+N-1,Start_x_0:Start_x_0+N-1,:)=128*ones(N,N,3);
im_affich=imresize(img_maze0,[512 512]);
imshow(im_affich); title('Maze size 10x10'); axis square;

% Compteur pas vers la cible
Cmp_cible=0;
Out_zone_pinal=2;
figure(1);

while(1)
    
    % Read data from serial port (attente)
    while(1)
        DataArduino = fscanf(SerialCOM,'%d');
        if (DataArduino~=99)
            break;
        end;
    end;
    
    % Obtenir le vecteur Manette
    Manette = ManetteVal( DataArduino );
    
    % Extraction des valeurs
    Down =Manette(1);
    Up=Manette(2);
    Right =Manette(3);
    Left=Manette(4);
    
    % Dplacement
    if Up~0
        Start_y=Start_y_0+Pas;
    elseif Down~0
        Start_y=Start_y_0-Pas;
        if Start_y <=0
            Start_y=1;
        end;
    end;
    if Right~0
        Start_x=Start_x_0+Pas;
    elseif Left~0
        Start_x=Start_x_0-Pas;
        if Start_x <=0
            Start_x=1;
        end;
    end;
    
    %  Calcul de la valeur moyenne de la position actuelle
    
    % Extraction du bloc NxN
    im_0= img_maze0(Start_y:Start_y+N-1,Start_x:Start_x+N-1,:);
    
    % Conversion RGB => Gray
    im_0=rgb2gray(im_0);
    
    % Caclul de la valeur moyenne
    mean_pixel=mean(im_0(:));
    
    % Gestion du compteur: Incrmentation ou Pnalit
    if(mean_pixel < Seuil_outZone)
        % Affichage
        img_maze0(Start_y:Start_y+N-1,Start_x:Start_x+N-1,:)=128*ones(N,N,3);
        im_gray=im2uint8(imresize(img_maze0,[512 512]));
        imshow(im_gray); title('Maze size 10x10'); axis square;
        
        % Mise  jour
        Start_y_0=Start_y;
        Start_x_0=Start_x;
        Cmp_cible=Cmp_cible+1;
    else
        Cmp_cible=Cmp_cible+Out_zone_pinal;
    end
    
    % Affichage score
    disp('Votre compteur:');
    disp(Cmp_cible);
    
    % Dlai & Init
    pause(0.5);
    Manette=ones(1,4);
    img_maze0=img_maze;
end

%% Port Delete (Previous port if exist)

Delete(SerialCOM);